﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace CheckBoxList_EF_MVC_Core.Controllers
{
    public class HomeController : Controller
    {
        private DBCtx Context { get; }
        public HomeController(DBCtx _context)
        {
            this.Context = _context;
        }

        public IActionResult Index()
        {
            return View(this.PopulateHobbies());
        }

        [HttpPost]
        public IActionResult Index(string[] hobby)
        {
            ViewBag.Message = "Selected Items:\\n";
            List<SelectListItem> items = this.PopulateHobbies();
            foreach (SelectListItem item in items)
            {
                if (hobby.Contains(item.Value))
                {
                    item.Selected = true;
                    ViewBag.Message += string.Format("{0}\\n", item.Text);
                }
            }

            return View(items);
        }

        private List<SelectListItem> PopulateHobbies()
        {
            List<SelectListItem> hobbiesList = (from p in this.Context.Hobbies
                                                select new SelectListItem
                                                {
                                                    Text = p.Hobby,
                                                    Value = p.HobbyId.ToString()
                                                }).ToList();

            return hobbiesList;
        }
    }
}